# -*- coding: utf_8 -*-
# setup.py
from distutils.core import setup
import py2exe
import glob
import sys

if __name__ == '__main__':
    # Import Psyco if available
    try:
        import psyco
        psyco.full()
        # psyco.log()
        # psyco.profile()
    except ImportError:
        pass
    # ...your code here...


# If run without args, build executables, in quiet mode.
if len(sys.argv) == 1:
    sys.argv.append("py2exe")
    sys.argv.append("-q")

#grab ver info
from res import *

def grabBuild():
    fp = file("revision.txt")
    fp.readline()
    data = fp.readline()
    fp.close()
    return data[len("Last committed at revision "):]
    
ver = "0.0.0.1"#+grabBuild()

class Target:
    def __init__(self, **kw):
        self.__dict__.update(kw)
        # for the versioninfo resources
        #self.build = grabVer()
        self.version = ver
        self.company_name = "None"
        self.copyright = "GPL"
        self.name = IDS_TITLE

################################################################
# A program using wxPython

# The manifest will be inserted as resource into test_wx.exe.  This
# gives the controls the Windows XP appearance (if run on XP ;-)
#
# Another option would be to store it in a file named
# test_wx.exe.manifest, and copy it with the data_files option into
# the dist-dir.
#
manifest_template = '''
<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<assembly xmlns="urn:schemas-microsoft-com:asm.v1" manifestVersion="1.0">
<assemblyIdentity
    version="5.0.0.0"
    processorArchitecture="x86"
    name="%(prog)s"
    type="win32"
/>
<description>%(prog)s Program</description>
<dependency>
    <dependentAssembly>
        <assemblyIdentity
            type="win32"
            name="Microsoft.Windows.Common-Controls"
            version="6.0.0.0"
            processorArchitecture="X86"
            publicKeyToken="6595b64144ccf1df"
            language="*"
        />
    </dependentAssembly>
</dependency>
</assembly>
'''

RT_MANIFEST = 24

import res
icon_list = list()

#icon list, for binding with exe
icon_list.append((0, res.id_path_dict[ID_PROGICON])) #for PE exe
icon_list.append((1, res.id_path_dict[ID_PROGICON])) #I don't know
res_id_keys = res.id_path_dict.keys()
res_id_keys.sort()
for key in res_id_keys:
    icon_list.append((key, res.id_path_dict[key]))

thbgm = Target(
    # used for the versioninfo resource
    description = IDS_ABOUT_MESSAGE,

    # what to build
    script = "thbgm.py",
    other_resources = [(RT_MANIFEST, 1, manifest_template % dict(prog="thbgm"))],
    icon_resources = icon_list,
    dest_base = "thbgm")

################################################################

setup(
    options = {"py2exe": {"compressed": 1,
                          "optimize": 2,
                          # "ascii": 1,
                          #"xref": 1,
                          #"skip_archive": 1,
                          "bundle_files": 1,
                          #"dll_excludes": [("msvcr71.dll"),],
                          }},
    zipfile=None,
    windows = [thbgm],
    
    # data_files=[
        # ("icons",glob.glob("icons\\*.ico")),
        # ("origicons",glob.glob("origicons\\*.ico")),
        # ("origicons",glob.glob("origicons\\*.txt")),
        # ("",glob.glob("*.dll")),
        # ("",glob.glob("*.ico"))
        # ]

    )

