﻿# -*- coding: utf_8 -*-
import shared
#from wxPython.wx import *
import wx
from res import *
import pygame

class thbgmPlayer(wx.Frame):
    TaskBarIcon = None
    def __init__(self, parent, id, title):

        wx.Frame.__init__(self, parent, id, title, size = (512,188), style= wx.DEFAULT_FRAME_STYLE)
        
        # set window icon
        self.SetIcon(GetIconRes(ID_PROGICON))
        
        self.TaskBarIcon = wx.TaskBarIcon()
        wx.EVT_TASKBAR_LEFT_UP(self.TaskBarIcon, self.EvnTray)
        
        self.BuildMenuBar()
        self.BuildToolBar()
        
        shared.status = self.CreateStatusBar()

        panel = wx.Panel(self)
        
        self.songChoiceCtl = wx.Choice(panel, id=ID_SONG_CHOICE)
        shared.songChoiceCtl = self.songChoiceCtl
        wx.EVT_CHOICE(self, ID_SONG_CHOICE, self.EvnSongChoiceCtl)
        
        shared.slider = wx.Slider(panel, style=wx.SL_HORIZONTAL | wx.SL_AUTOTICKS)
        shared.slider.SetRange(0, 1)
        shared.slider.Enable(False)
        wx.EVT_SCROLL_THUMBTRACK(self, self.EvnSlider)
        wx.EVT_SCROLL_THUMBRELEASE(self, self.EvnSlider)

        shared.songStatus = wx.StaticText(panel, style=wx.ST_NO_AUTORESIZE|wx.ALIGN_CENTRE)
        shared.songStatus.SetFont(wx.Font(12, wx.MODERN, wx.NORMAL, wx.NORMAL, False))
        shared.songStatus.SetLabel("")
        
        sizer = wx.FlexGridSizer(cols=1, vgap=0, hgap=0)
#       sizer.AddGrowableRow(2)
        sizer.AddGrowableCol(0)
        sizer.SetFlexibleDirection(wx.HORIZONTAL)

        sizer.Add(shared.songChoiceCtl, flag=wx.EXPAND)
        sizer.Add(shared.slider, flag=wx.EXPAND)
        sizer.Add(shared.songStatus, flag=wx.EXPAND)

        panel.SetSizer(sizer)
        panel.SetAutoLayout(True)
        panel.Layout()

        # EVT_CHAR(self, self.EvnKeyPress)
        
        shared.event.post(shared.event.Event(shared.EVENT_FRAMEUPD, {"Ctl":"Init"}))
        self.Show(True)
    def BuildMenuBar(self):
        menuBar = wx.MenuBar()
        
        #operationMenu = wxMenu()
        #operationMenu.Append(ID_EXIT, IDS_EXIT)
        #EVT_MENU(self, ID_EXIT, self.OnExit)
        #menuBar.Append(operationMenu, IDS_OPERATION)
        
        helpMenu    = wx.Menu()
        helpMenu.Append(ID_ABOUT, IDS_ABOUT)
        wx.EVT_MENU(self, ID_ABOUT, self.OnAbout)
        menuBar.Append(helpMenu, IDS_HELP)

        self.SetMenuBar(menuBar)
    def BuildToolBar(self):
        self.toolBar = self.CreateToolBar()
        shared.toolBar = self.toolBar
        
        self.toolBar.AddTool(ID_CTL_PREV, GetBitmapRes(ID_CTL_PREV))
        self.toolBar.AddRadioTool(ID_CTL_STOP, GetBitmapRes(ID_CTL_STOP))
        self.toolBar.AddRadioTool(ID_CTL_PAUSE, GetBitmapRes(ID_CTL_PAUSE))
        self.toolBar.AddRadioTool(ID_CTL_PLAY, GetBitmapRes(ID_CTL_PLAY))
        self.toolBar.AddTool(ID_CTL_NEXT, GetBitmapRes(ID_CTL_NEXT))
        self.toolBar.SetToolShortHelp(ID_CTL_PREV, IDS_CTL_PREV)
        self.toolBar.SetToolShortHelp(ID_CTL_STOP, IDS_CTL_STOP)
        self.toolBar.SetToolShortHelp(ID_CTL_PAUSE, IDS_CTL_PAUSE)
        self.toolBar.SetToolShortHelp(ID_CTL_PLAY, IDS_CTL_PLAY)
        self.toolBar.SetToolShortHelp(ID_CTL_NEXT, IDS_CTL_NEXT)
        wx.EVT_TOOL(self, ID_CTL_PREV, self.EvnCtl)
        wx.EVT_TOOL(self, ID_CTL_STOP, self.EvnCtl)
        wx.EVT_TOOL(self, ID_CTL_PAUSE, self.EvnCtl)
        wx.EVT_TOOL(self, ID_CTL_PLAY, self.EvnCtl)
        wx.EVT_TOOL(self, ID_CTL_NEXT, self.EvnCtl)
        
        self.toolBar.AddSeparator()
        self.toolBar.AddRadioTool(ID_ORDER_SEQUENCE, GetBitmapRes(ID_ORDER_SEQUENCE))
        self.toolBar.AddRadioTool(ID_ORDER_SHUFFLE, GetBitmapRes(ID_ORDER_SHUFFLE))
        self.toolBar.AddRadioTool(ID_ORDER_REPEAT, GetBitmapRes(ID_ORDER_REPEAT))
        self.toolBar.SetToolShortHelp(ID_ORDER_SEQUENCE, IDS_SEQUENCE)
        self.toolBar.SetToolShortHelp(ID_ORDER_SHUFFLE, IDS_SHUFFLE)
        self.toolBar.SetToolShortHelp(ID_ORDER_REPEAT, IDS_REPEAT)
        wx.EVT_TOOL(self, ID_ORDER_SEQUENCE, self.EvnPlayOreder)
        wx.EVT_TOOL(self, ID_ORDER_SHUFFLE, self.EvnPlayOreder)
        wx.EVT_TOOL(self, ID_ORDER_REPEAT, self.EvnPlayOreder)
        
        self.toolBar.AddSeparator()
        self.toolBar.AddTool(ID_CTL_LOOPINC, GetBitmapRes(ID_CTL_LOOPINC))
        self.toolBar.AddTool(ID_CTL_LOOPDEC, GetBitmapRes(ID_CTL_LOOPDEC))
        self.toolBar.SetToolShortHelp(ID_CTL_LOOPINC, IDS_CTL_LOOPINC)
        self.toolBar.SetToolShortHelp(ID_CTL_LOOPDEC, IDS_CTL_LOOPDEC)
        wx.EVT_TOOL(self, ID_CTL_LOOPINC, self.EvnLoopTimes)
        wx.EVT_TOOL(self, ID_CTL_LOOPDEC, self.EvnLoopTimes)
        
        self.toolBar.AddSeparator()
        self.toolBar.AddCheckTool(ID_TH06_BGM, GetBitmapRes(ID_TH06_BGM))
        self.toolBar.AddCheckTool(ID_TH07_BGM, GetBitmapRes(ID_TH07_BGM))
        self.toolBar.AddCheckTool(ID_TH075_BGM, GetBitmapRes(ID_TH075_BGM))
        self.toolBar.AddCheckTool(ID_TH08_BGM, GetBitmapRes(ID_TH08_BGM))
        self.toolBar.AddCheckTool(ID_TH09_BGM, GetBitmapRes(ID_TH09_BGM))
        self.toolBar.AddCheckTool(ID_TH095_BGM, GetBitmapRes(ID_TH095_BGM))
        self.toolBar.AddCheckTool(ID_TH10_BGM, GetBitmapRes(ID_TH10_BGM))
        self.toolBar.AddCheckTool(ID_TH105_BGM, GetBitmapRes(ID_TH105_BGM))
        self.toolBar.AddCheckTool(ID_TH11tr_BGM, GetBitmapRes(ID_TH11tr_BGM))
        self.toolBar.SetToolShortHelp(ID_TH06_BGM, shared.thBGMdata.getSeriesFullNameByRes(ID_TH06_BGM))
        self.toolBar.SetToolShortHelp(ID_TH07_BGM, shared.thBGMdata.getSeriesFullNameByRes(ID_TH07_BGM))
        self.toolBar.SetToolShortHelp(ID_TH075_BGM, shared.thBGMdata.getSeriesFullNameByRes(ID_TH075_BGM))
        self.toolBar.SetToolShortHelp(ID_TH08_BGM, shared.thBGMdata.getSeriesFullNameByRes(ID_TH08_BGM))
        self.toolBar.SetToolShortHelp(ID_TH09_BGM, shared.thBGMdata.getSeriesFullNameByRes(ID_TH09_BGM))
        self.toolBar.SetToolShortHelp(ID_TH095_BGM, shared.thBGMdata.getSeriesFullNameByRes(ID_TH095_BGM))
        self.toolBar.SetToolShortHelp(ID_TH10_BGM, shared.thBGMdata.getSeriesFullNameByRes(ID_TH10_BGM))
        self.toolBar.SetToolShortHelp(ID_TH105_BGM, shared.thBGMdata.getSeriesFullNameByRes(ID_TH105_BGM))
        self.toolBar.SetToolShortHelp(ID_TH11tr_BGM, shared.thBGMdata.getSeriesFullNameByRes(ID_TH11tr_BGM))
        wx.EVT_TOOL(self, ID_TH06_BGM, self.EvnSelTHBGM)
        wx.EVT_TOOL(self, ID_TH07_BGM, self.EvnSelTHBGM)
        wx.EVT_TOOL(self, ID_TH075_BGM, self.EvnSelTHBGM)
        wx.EVT_TOOL(self, ID_TH08_BGM, self.EvnSelTHBGM)
        wx.EVT_TOOL(self, ID_TH09_BGM, self.EvnSelTHBGM)
        wx.EVT_TOOL(self, ID_TH095_BGM, self.EvnSelTHBGM)
        wx.EVT_TOOL(self, ID_TH10_BGM, self.EvnSelTHBGM)
        wx.EVT_TOOL(self, ID_TH105_BGM, self.EvnSelTHBGM)
        wx.EVT_TOOL(self, ID_TH11tr_BGM, self.EvnSelTHBGM)
        
        self.toolBar.AddSeparator()
        self.toolBar.AddCheckTool(ID_CTL_ENABLETRAY, GetBitmapRes(ID_CTL_ENABLETRAY))
        self.toolBar.SetToolShortHelp(ID_CTL_ENABLETRAY, IDS_MINITOTRAY)
        wx.EVT_TOOL(self, ID_CTL_ENABLETRAY, self.EvnEnableTray)

        self.toolBar.Realize()
        
    def __del__(self):
        shared.programExit.set()
        shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Stop"}))
        shared.event.post(shared.event.Event(pygame.QUIT))
        shared.eventTakerQuit.wait()
        self.TaskBarIcon.Destroy()
    def OnExit(self,event):
        print "onexit"
        self.Close(True)
    def OnClose(self,event):
        print "onclose"
    def OnAbout(self,event):
        dlg = wx.MessageDialog(self, IDS_ABOUT_MESSAGE, IDS_ABOUT, wx.OK)
        dlg.ShowModal()
        dlg.Destroy()
    def EvnEnableTray(self,event):
        if self.toolBar.GetToolState(event.GetId()) == True:
            self.TaskBarIcon.SetIcon(GetIconRes(ID_CTL_ENABLETRAY))
            self.Show(False)
        else:
            self.TaskBarIcon.RemoveIcon()
    def EvnTray(self,event):
        self.TaskBarIcon.RemoveIcon()
        self.toolBar.ToggleTool(ID_CTL_ENABLETRAY, False)
        self.Show(True)
    def EvnCtl(self,event):
        if event.GetId() == ID_CTL_PLAY:
            shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Play"}))
        elif event.GetId() == ID_CTL_PAUSE:
            shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Pause"}))
        elif event.GetId() == ID_CTL_STOP:
            shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Stop"}))
        elif event.GetId() == ID_CTL_PREV:
            shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Prev"}))
        elif event.GetId() == ID_CTL_NEXT:
            shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Next"}))
    def EvnKeyPress(self,event):
        if event.GetKeyCode() == ord('z') or event.GetKeyCode() == ord('Z'):
            shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Prev"}))
        elif event.GetKeyCode() == ord('x') or event.GetKeyCode() == ord('X'):
            shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Stop"}))
        elif event.GetKeyCode() == ord('c') or event.GetKeyCode() == ord('C'):
            shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Pause"}))
        elif event.GetKeyCode() == ord('v') or event.GetKeyCode() == ord('V'):
            shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Play"}))
        elif event.GetKeyCode() == ord('b') or event.GetKeyCode() == ord('B'):
            shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Next"}))
    def EvnSlider(self,event):
        if event.GetEventType() == wx.EVT_SCROLL_THUMBTRACK.evtType[0]:
            shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Scrolling", "Pos":shared.slider.GetValue()}))
        elif event.GetEventType() == wx.EVT_SCROLL_THUMBRELEASE.evtType[0]:
            shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Scroll", "Pos":shared.slider.GetValue()}))
    def EvnSongChoiceCtl(self,event):
        shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Choice", "idx":self.songChoiceCtl.GetSelection()}))
    def EvnSelTHBGM(self,event):
        series = shared.thBGMdata.refResToSeries(event.GetId())
        if self.toolBar.GetToolState(event.GetId()) == False: 
            shared.playingInfo.userEnableSeries(series, False)
            if shared.playingInfo.isPlayable() == False:
                shared.event.post(shared.event.Event(shared.EVENT_SOUNDCTL, {"Ctl":"Stop"}))
        else:
            if shared.playingInfo.userEnableSeries(series, True) == False:
                dlg = wx.DirDialog(self)
                if (dlg.ShowModal() == wx.ID_OK):
                    if shared.thBGMdata.selfCerSeriesPathExam(series, dlg.GetPath()) == True:
                        shared.playingInfo.userEnableSeries(series, True)
                        dlg.Destroy()
                    else:
                        dlgMsg = wx.MessageDialog(self, IDS_FAILEDTOLOC, IDS_FAILED, style = wx.OK)
                        dlgMsg.ShowModal()
                        dlgMsg.Destroy()
                        self.toolBar.ToggleTool(event.GetId(), False)
                else:
                    self.toolBar.ToggleTool(event.GetId(), False)
        shared.event.post(shared.event.Event(shared.EVENT_FRAMEUPD, {"Ctl":"UpdateSelTHBGM"}))
    def EvnPlayOreder(self,event):
        shared.event.post(shared.event.Event(shared.EVENT_INFOUPD, {"Ctl":"SetPlayingOrder", "evnId":event.GetId()}))
    def EvnLoopTimes(self,event):
        if event.GetId() == ID_CTL_LOOPINC:
            shared.playingInfo.incLoopPlayTimes()
        elif event.GetId() == ID_CTL_LOOPDEC:
            shared.playingInfo.decLoopPlayTimes()
            
class thbgmPlayerMain(wx.App):
    def OnInit(self):
        frame = thbgmPlayer(None, -1, IDS_TITLE)
        self.SetTopWindow(frame)
        #wx.UpdateUIEvent.SetUpdateInterval(-1)
        #wx.UpdateUIEvent.SetMode(1)
        return True
    def OnExit(self):
        pass

def run():
    app = thbgmPlayerMain(redirect = 0)
    app.MainLoop()

